summaryrefslogtreecommitdiff
path: root/dev-util
diff options
context:
space:
mode:
Diffstat (limited to 'dev-util')
-rw-r--r--dev-util/google-perftools/google-perftools-scm.ebuild85
-rw-r--r--dev-util/google-perftools/metadata.xml26
2 files changed, 111 insertions, 0 deletions
diff --git a/dev-util/google-perftools/google-perftools-scm.ebuild b/dev-util/google-perftools/google-perftools-scm.ebuild
new file mode 100644
index 0000000..312604f
--- /dev/null
+++ b/dev-util/google-perftools/google-perftools-scm.ebuild
@@ -0,0 +1,85 @@
+# Copyright 1999-2017 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=6
+
+inherit toolchain-funcs flag-o-matic vcs-snapshot autotools multilib-minimal git-r3
+
+DESCRIPTION="Fast, multi-threaded malloc() and nifty performance analysis tools"
+HOMEPAGE="https://github.com/gperftools/gperftools"
+SRC_URI=""
+
+EGIT_REPO_URI="https://github.com/gperftools/gperftools.git"
+
+LICENSE="MIT"
+SLOT="0/4"
+# contains ASM code, with support for
+# freebsd x86/amd64
+# linux x86/amd64/ppc/ppc64/arm
+# OSX ppc/amd64
+# AIX ppc/ppc64
+KEYWORDS=""
+IUSE="largepages +debug minimal optimisememory test static-libs"
+
+DEPEND="sys-libs/libunwind"
+RDEPEND="${DEPEND}"
+
+
+HTML_DOCS="docs"
+
+pkg_setup() {
+ # set up the make options in here so that we can actually make use
+ # of them on both compile and install.
+
+ # Avoid building the unit testing if we're not going to execute
+ # tests; this trick here allows us to ignore the tests without
+ # touching the build system (and thus without rebuilding
+ # autotools). Keep commented as long as it's restricted.
+ use test || \
+ MAKEOPTS+=" noinst_PROGRAMS= "
+}
+
+src_prepare() {
+ default
+ eautoreconf
+ multilib_copy_sources
+}
+
+multilib_src_configure() {
+ use largepages && append-cppflags -DTCMALLOC_LARGE_PAGES
+ use optimisememory && append-cppflags -DTCMALLOC_SMALL_BUT_SLOW
+ append-flags -fno-strict-aliasing -fno-omit-frame-pointer
+
+ econf \
+ --htmldir=${EPREFIX}/usr/share/doc/${PF}/html \
+ --docdir=${EPREFIX}/usr/share/doc/${PF} \
+ --enable-shared \
+ $(use_enable static-libs static) \
+ $(use_enable debug debugalloc) \
+ $(if [[ ${ABI} == x32 ]]; then printf "--enable-minimal\n" else use_enable minimal; fi)
+}
+
+src_test() {
+ case "${LD_PRELOAD}" in
+ *libsandbox*)
+ ewarn "Unable to run tests when sandbox is enabled."
+ ewarn "See https://bugs.gentoo.org/290249"
+ return 0
+ ;;
+ esac
+
+ multilib-minimal_src_test
+}
+
+src_install() {
+ if ! use minimal && has x32 ${MULTILIB_ABIS}; then
+ MULTILIB_WRAPPED_HEADERS=(
+ /usr/include/gperftools/heap-checker.h
+ /usr/include/gperftools/heap-profiler.h
+ /usr/include/gperftools/stacktrace.h
+ /usr/include/gperftools/profiler.h
+ )
+ fi
+
+ multilib-minimal_src_install
+}
diff --git a/dev-util/google-perftools/metadata.xml b/dev-util/google-perftools/metadata.xml
new file mode 100644
index 0000000..e6791a6
--- /dev/null
+++ b/dev-util/google-perftools/metadata.xml
@@ -0,0 +1,26 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+ <use>
+ <flag name="largepages">
+ Use (experimental) larger pages for tcmalloc, this increases
+ memory usage, but should speed up the allocation/free
+ operations.
+ </flag>
+ <flag name="debug">
+ Build a set of libraries with debug support (so-called
+ debugalloc). These are available by default but are not needed
+ unless you're actually developing using tcmalloc.
+ </flag>
+ <flag name="minimal">
+ Only build the tcmalloc_minimal library, ignoring the heap
+ checker and the profilers.
+ </flag>
+ <flag name="optimisememory">
+ To build libtcmalloc with smaller internal caches.
+ </flag>
+ </use>
+ <upstream>
+ <remote-id type="github">gperftools/gperftools</remote-id>
+ </upstream>
+</pkgmetadata>